// C api for rngxx
#ifndef _RNGXX_H
#define _RNGXX_H

#ifndef _RNGXX_IMPL
#define _RNGXX_COMMON_MINIMAL
#endif
#include "rngxx/internal/common.h"
#ifndef _RNGXX_IMPL
#undef _RNGXX_COMMON_MINIMAL
#endif

#ifdef __cplusplus
#ifndef _RNGXX_IMPL_ONLY_TYPES
#warning "C++ compilers might not like this header file. Please use the C++ interface for C++ TUs"
#endif
extern "C" {
#endif

// -- C API types -- (C++ compat)
typedef struct Random rng_t;

enum rng_kind {
	RNG_KIND_CRAND,
};

// -- // --
#ifndef _RNGXX_IMPL_ONLY_TYPES
// -- C API functions -- (C++ NO compat)
rng_t* rng_new(enum rng_kind kind, u64 seed[static restrict 1]);

// -- // --
#endif
#ifdef __cplusplus
}
#endif

#endif /* _RNGXX_H */
